<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref, onMounted, onBeforeUnmount, computed, inject } from 'vue';
import { storeToRefs } from 'pinia';
import Button from '@/components/general/Button.vue';
import CategoryBadge from '@/components/chat/PersonsCategoryBadge.vue';
import Dropdown from '@/components/general/Dropdown.vue';
import { useAccountStore } from '@/stores/account';
import { useChatStore } from '@/stores/chat';


const accountStore = useAccountStore();
const chatStore = useChatStore();
const { mail } = storeToRefs(accountStore);
const { state, uuid } = storeToRefs(chatStore);
const configuration = inject<any>('configuration');

const props = defineProps<{
    uuid: string,
    name: string,
    username: string,
    avatar?: string,
    description?: string
    shared?: boolean,
    systemprompt: string,
    categories: string[],
    size?: string,
    model: string
}>();

const isAdditionalInfoOpen = ref(false);
const handleShowAdditionalInfo = () => {
    isAdditionalInfoOpen.value = !isAdditionalInfoOpen.value;
};

const localCategories = ref<{ label: string, colorClass: string }[]>([]);

const element = ref();
onMounted(() => {
    const categories = configuration.ai.personCategories;
    if (props.categories[0] === null) {
        localCategories.value = [];
    } else {
        localCategories.value = props.categories.map((category) => {
            const cat = categories.find((item: any) => item.value === category);
            if (cat)
                return { label: cat.label, colorClass: cat.colorClass };
            else return { label: undefined, colorClass: undefined };
        })
    }
    document.addEventListener('click', handleCheckOutsideClick);
});

onBeforeUnmount(() => {
    document.removeEventListener('click', handleCheckOutsideClick);
});

const handleCheckOutsideClick = (e: any) => {
    /*if(!element.value.contains(e.target) && isAdditionalInfoOpen.value===true){
        isAdditionalInfoOpen.value = false;
    }*/
};

const handleStartChat = () => {
    state.value = "PERSON_CHAT_CREATE";
    uuid.value = props.uuid;
};

const filePath = computed(() => {
    if (props.avatar)
        return configuration.apiServer + props.avatar.replace(/<p>/g, '').replace(/<\/p>/g, '');
    else return undefined;
});

const handleEdit = () => {
    state.value = "PERSON_EDIT";
    uuid.value = props.uuid;
};

const handleDelete = () => {
    state.value = "PERSON_DELETE";
    uuid.value = props.uuid;
}

const containerSize = props.size && props.size === "small" ? "min-w-60 min-h-60 max-w-60 max-h-60" : "min-w-80 min-h-80 max-w-80 max-h-80";
const contentSize = props.size && props.size === "small" ? "min-w-52 w-52" : "min-w-72 w-72";
const avatarSize = props.size && props.size === "small" ? "size-10" : "size-20";

const shortBadges = computed(() => { return localCategories.value.length > 3 ? localCategories.value.slice(0, 4) : localCategories.value });
const lastBadges = computed(() => { return localCategories.value.length > 4 ? localCategories.value.slice(4, -1) : [] });

const modelLabel = computed(()=>{
    const chatModel = configuration.ai.models.chat.find((model:{value:string, label:string})=>model.value===props.model);
    if(chatModel){
        return chatModel.label;
    }else{
        return props.model;
    }
});

</script>
<template>
    <div class="bg-white rounded-lg shadow-md relative select-none mb-4" ref="element" :class="containerSize">
        <div class="flex flex-row h-full">
            <div class="z-10 absolute top-1/3 left-1">
                <Tooltip :tooltip="$t('ai.person.basicInformation')" v-if="isAdditionalInfoOpen">
                    <button class="hover:text-gray-700 text-gray-500 hover:bg-gray-100 rounded-full size-5"
                        @click="handleShowAdditionalInfo">
                        <strong><i class="ri-arrow-left-wide-line"></i></strong>
                    </button>
                </Tooltip>
            </div>
            <div class="p-4 flex flex-row overflow-hidden">
                <div class="transition-transform duration-500" :class="contentSize"
                    :style="{ transform: isAdditionalInfoOpen ? 'translateX(-120%)' : 'translateX(0%)' }">
                    <div class="flex flex-col justify-between h-full">
                        <div class="h-5 flex flex-row gap-1 w-full max-w-[100%-20px]">
                            <template v-for="item in shortBadges">
                                <CategoryBadge :label="item.label" :colorClass="item.colorClass" v-if="item" />
                            </template>
                            <Dropdown v-if="lastBadges.length > 0">
                                <template #button>
                                    <button
                                        class="border border-gray-500 rounded-full size-4 mt-1 leading-4 hover:bg-gray-100"><i
                                            class="ri-more-line"></i></button>
                                </template>
                                <div class="flex flex-col gap-1">
                                    <div v-for="item in lastBadges" :class="item.colorClass"
                                        class="text-center rounded-full">{{ item.label }}</div>

                                </div>
                            </Dropdown>
                            <div class="size-4 ml-auto">
                                <Dropdown width="w-fit" v-if="mail === username">
                                    <template #button>
                                        <Tooltip :tooltip="$t('tooltips.settings')">
                                            <button
                                                class="hover:bg-gray-100 rounded-full size-4 text-center leading-4 align-middle"><strong><i
                                                        class="ri-more-fill text-gray-500"></i></strong></button>
                                        </Tooltip>
                                    </template>
                                    <div class="flex flex-col gap-1 text-left w-full">
                                        <button @click="handleEdit"
                                            class="flex flex-row gap-2 w-full hover:bg-gray-100 rounded-md px-2 py-1"
                                            v-if="mail === username"><i class="ri-pencil-line text-blue-700"></i>{{
                                            $t('ai.person.item.edit') }}</button>
                                        <button @click="handleDelete"
                                            class="flex flex-row gap-2 w-full hover:bg-gray-100 rounded-md px-2 py-1"
                                            v-if="mail === username"><i class="ri-delete-bin-line text-red-700"></i>{{
                                            $t('ai.person.item.delete') }}</button>
                                        <!--<button
                                            class="flex flex-row gap-2 w-full hover:bg-gray-100 rounded-md px-2 py-1"
                                            v-if="mail !== username"><i class="ri-flag-fill text-red-700"></i>{{
                                            $t('ai.person.item.report') }}</button>-->
                                    </div>
                                </Dropdown>
                            </div>
                        </div>
                        <div class="mt-1">
                            <div class="flex flex-row justify-center">
                                <div class="bg-gray-200 text-gray-400 rounded-full mb-1 flex flex-col justify-center"
                                    :class="avatarSize" v-if="!avatar"><i class="ri-user-line text-center w-full block"
                                        :class="size === 'small' ? 'ri-lg' : 'ri-3x'"></i>
                                </div>
                                <div class="rounded-full" :class="avatarSize" v-else><img
                                        class="rounded-full h-full w-full object-contain" :class="avatarSize"
                                        :src="filePath" alt="avatar" /></div>
                            </div>
                            <Tooltip :tooltip="name">
                                <h3 class="text-center w-full text-lg line-clamp-1 text-ellipsis hyphens-auto"
                                    lang="de">{{
                                    name }}</h3>
                            </Tooltip>
                            <h4
                                class="text-center text-gray-400 line-clamp-1 text-ellipsis block hyphens-auto text-sm px-2">
                                {{
                                username }}</h4>

                        </div>
                        <div class="h-11 rounded-full shadow-md bg-gray-200 flex flex-row p-2 px-3 w-full gap-4 my-1">

                            <Button variant="accent1" size="small" @click="handleStartChat"><i
                                    class="ri-chat-1-line mr-1"></i>{{
                                $t('ai.person.item.chat') }}</Button>
                        </div>
                        <div class="h-10">
                            <Tooltip :tooltip="description">
                                <div class="text-gray-400 text-ellipsis text-justify hyphens-auto h-10"
                                    :class="size === 'small' ? 'line-clamp-2' : 'line-clamp-3'" lang="de"
                                    v-html="description">
                                </div>
                            </Tooltip>
                        </div>
                    </div>
                </div>
                <div class="transition-transform duration-500" :class="contentSize"
                    :style="{ transform: isAdditionalInfoOpen ? 'translateX(-100%)' : 'translateX(10%)' }">
                    <div class="flex flex-col h-full gap-2">
                        <label class="flex flex-row gap-2">{{ $t("ai.chat.information.model") }}<div class="text-gray-500">{{ modelLabel }}</div></label>
                        
                        <label v-if="systemprompt">{{ $t('ai.person.create.systemprompt.label') }}</label>
                        <div class="w-full hyphens-auto bg-gray-100 p-2 text-justify rounded-md font-mono overflow-scroll text-gray-600"
                            lang="de" v-if="systemprompt">{{
                            systemprompt }}</div>
                    </div>
                </div>
            </div>
            <div class="z-10 absolute top-1/3 right-1">
                <Tooltip :tooltip="$t('ai.person.additionalInformation')" v-if="!isAdditionalInfoOpen">
                    <button class="hover:text-gray-700 text-gray-500 hover:bg-gray-100 rounded-full size-5"
                        @click="handleShowAdditionalInfo">
                        <strong><i class="ri-arrow-right-wide-line"></i></strong>
                    </button>
                </Tooltip>
            </div>
        </div>
    </div>
</template>
